﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using iSDK;

namespace iSDKExample
{
    public partial class Form1 : Form
    {
        public iSDKCL mycl = new iSDKCL();                           //using iSDK must be at top of file
        public int BAUD = 9600;
        public Boolean PORTCONNECTED = false;
        int TIMEOUT = 1000;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            int err = 0;
            if (!PORTCONNECTED)
            {

                err = mycl.PortConnect(BAUD);
                if (err == 0)
                {
                    PORTCONNECTED = true;
                    btnConnect.Text = "Com Disconnect";
                    mycl.FlushPort();
                    groupBox1.Enabled = true;
                    groupBox2.Enabled = true;
                }
                else
                {
                    DialogResult result1 = MessageBox.Show("Click to Exit", "Port Connection Error", MessageBoxButtons.OK);
                    if (result1 == DialogResult.OK) this.Close();
                }
            }
            else
            {
                PORTCONNECTED = false;
                btnConnect.Text = "Com Connect";
                mycl.ClosePort();
                groupBox1.Enabled = false;
                groupBox2.Enabled = false;
            }


        }

        private void btnWrite_Click(object sender, EventArgs e)
        {
            String Target = txtTarget.Text;
            String Index = txtIndex.Text;
            String Data = txtData.Text;
            String Checksum = mycl.Checksum(Data);
            String resp = "";
            txtCS.Text = Checksum;
            resp = mycl.UniversalSend("w", Target, Index, Data, TIMEOUT);

            txtResp.Text = resp;

        }

        private void btnRead_Click(object sender, EventArgs e)
        {
            String Target = txtTarget.Text;
            String Index = txtIndex.Text;
            String Data = txtData.Text;
            String Checksum = mycl.Checksum(Data);
            String resp = "";
            txtCS.Text = Checksum;
            resp = mycl.UniversalSend("r", Target, Index, Data, TIMEOUT);

            txtResp.Text = resp;
        }

        private void btnExposure_Click(object sender, EventArgs e)
        {
            String resp = "";
            int Exposure = int.Parse(txtExposure.Text);
            resp = mycl.SetExpMS((ushort)Exposure);
            txtResp.Text = resp;
        }

        private void rad8Bit_CheckedChanged(object sender, EventArgs e)
        {
            String resp = "";
            resp = mycl.SetBitDepth(8);
            txtResp.Text = resp;
        }

        private void rad10Bit_CheckedChanged(object sender, EventArgs e)
        {
            String resp = "";
            resp = mycl.SetBitDepth(10);
            txtResp.Text = resp;
        }

        private void rad12Bit_CheckedChanged(object sender, EventArgs e)
        {
            String resp = "";
            resp = mycl.SetBitDepth(12);
            txtResp.Text = resp;
        }

        private void btnConnectSilent_Click(object sender, EventArgs e)
        {
            int err = 0;
            int port = int.Parse(txtPort.Text);

            if (!PORTCONNECTED)
            {
                err = mycl.PortNumberConnect(BAUD, port);
                if (err == 0)
                {
                    PORTCONNECTED = true;
                    btnConnectSilent.Text = "Com Disconnect Silent";
                    mycl.FlushPort();
                    groupBox1.Enabled = true;
                    groupBox2.Enabled = true;
                }
                else
                {
                    DialogResult result1 = MessageBox.Show("Click to Exit", "Port Connection Error", MessageBoxButtons.OK);
                    if (result1 == DialogResult.OK) this.Close();
                }
            }
            else
            {
                PORTCONNECTED = false;
                btnConnectSilent.Text = "Com Connect Silent";
                mycl.ClosePort();
                groupBox1.Enabled = false;
                groupBox2.Enabled = false;
            }

        }
    }
}
